----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 06/11/2017 11:37:39 PM
-- Design Name: 
-- Module Name: main_tb - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity main_tb is
end main_tb;

architecture Behavioral of main_tb is
    -- Component declaration for the UUT
    component main is
        Port ( clk : in STD_LOGIC;
               rst : in STD_LOGIC;
               vauxp3 : in STD_LOGIC;
               vauxn3 : in STD_LOGIC;
               vauxp10 : in std_logic;
               vauxn10 : in std_logic;
               vauxp2  : in std_logic;
               vauxn2  : in std_logic;
               vauxp11 : in std_logic;
               vauxn11 : in std_logic;
               --rxd : in STD_LOGIC;      -- UART recieve. Not (yet) being used.
               txd : out STD_LOGIC;     -- UART transmit.
               --rts : out STD_LOGIC;     -- Request to Send
               --cts : in STD_LOGIC;      -- Clear to Send
               uart_led : out std_logic;
               adc_led : out std_logic);
    end component;
    
    --Inputs
    signal clk     : std_logic := '0';
    signal rst     : std_logic := '1';
    signal vauxp3  : std_logic := '1';
    signal vauxn3  : std_logic := '0';
    signal vauxp10 : std_logic := '1';
    signal vauxn10 : std_logic := '0';
    signal vauxp2  : std_logic := '1';
    signal vauxn2  : std_logic := '0';
    signal vauxp11 : std_logic := '1';
    signal vauxn11 : std_logic := '0';
    
    --Outputs
    signal txd      : std_logic;
    signal uart_led : std_logic;
    signal adc_led  : std_logic;
    
    -- Clock period definition
    constant clk_period : time := 100 ns;
    
begin

    -- Instantiate the UUT
    UUT: main port map (
        clk      => clk,
        rst      => rst,
        vauxp3   => vauxp3,
        vauxn3   => vauxn3,
        vauxp10  => vauxp10,
        vauxn10  => vauxn10,
        vauxp2   => vauxp2,
        vauxn2   => vauxn2,
        vauxp11  => vauxp11,
        vauxn11  => vauxn11,
        txd      => txd,
        uart_led => uart_led,
        adc_led  => adc_led
    );
    
   -- Clock process definition
    clk_process: process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
    end process;
    
    --stimulus process
    stim_proc: process
    begin
        rst <= '1';
        wait for clk_period/2;
        rst <= '0';
        wait for clk_period*8;
        vauxp3  <= '0';
        vauxn3  <= '0';
        vauxp10 <= '0';
        vauxn10 <= '0';
        vauxp2  <= '0';
        vauxn2  <= '0';
        vauxp11 <= '0';
        vauxn11 <= '0';
        wait for clk_period*8;
        vauxp3  <= '0';
        vauxn3  <= '1';
        vauxp10 <= '0';
        vauxn10 <= '1';
        vauxp2  <= '0';
        vauxn2  <= '1';
        vauxp11 <= '0';
        vauxn11 <= '1';
        wait;
    end process;

end Behavioral;
